#!/bin/bash

 idchkpara_ok=1
 nseg_segave_OK=""
 segment_duration_OK=""
 smoothband_OK=""
 idmksegment_OK=""
 idprepro_OK=""
 idcalc_OK=""
 idgnplt_OK=""
 delete_level_OK=""

echo $nseg_segave | grep '[a-z,A-Z,-,\.]' >& /dev/null
if test "$?" == "0"; then
idchkpara_ok=0
nseg_segave_OK=" <-- Should be zero or a positive interger."
fi

echo $segment_duration | grep '[a-z,A-Z,-]' >& /dev/null
if test "$?" == "0"; then
idchkpara_ok=0
segment_duration_OK=" <-- Should be a positive real number."
fi

echo $smoothband | grep '[a-z,A-Z,-]' >& /dev/null
if test "$?" == "0"; then
idchkpara_ok=0
smoothband_OK=" <-- Should be zero or a positive real number."
fi

if test "$idmksegment" != "0" -a  "$idmksegment" != "1" ; then
idchkpara_ok=0
idmksegment_OK=" <-- Inappropriate parameter. Should be 0 or 1."
fi

if test "$idprepro" != "0" -a  "$idprepro" != "1" ; then
idchkpara_ok=0
idprepro_OK=" <-- Inappropriate parameter. Should be 0 or 1."
fi

if test "$idcalc" != "0" -a  "$idcalc" != "1"; then
idchkpara_ok=0
idcalc_OK=" <-- Inappropriate parameter. Should be 0 or 1."
fi

if test "$idgnplt" != "0" -a  "$idgnplt" != "1"; then
idchkpara_ok=0
idgnplt_OK=" <-- Inappropriate parameter. Should be 0 or 1."
fi

if test "$delete_level" != "0" -a  "$delete_level" != "1"; then
idchkpara_ok=0
delete_level_OK=" <-- Inappropriate parameter. Should be 0 or 1."
fi

ndum=`cat $seismfile | grep -v '^#' | awk 'BEGIN{n=0}{if($2!=""){n=n+1}}END{print n}'`
if [ $ndum -eq 0 ]
then
    echgo ERROR: No data file described in $seismfile
    echo STOP
    exit 1
elif [ $ndum -eq 1 ]
then
idcohcca=0 
else
idcohcca=1 
fi
