#!/bin/bash
# Shell script for Packege BIDO
# (C) 2009 I. Cho All Rights Reserved.

echo "<SPECRATIO HV>"

FILES="$outputdir2/wavud_wavud.d $outputdir2/wavew_wavew.d $outputdir2/wavns_wavns.d"
for file in $FILES;do
. script/chkfile.sh $file; done

echo "OUTPUT (for HV spectral ratio) " $spr_hvfile
paste $FILES| awk '{freq=$1;v=$2;ew=$6;ns=$10;h=ew+ns
if(v!=0){printf "%g\t%g\n",freq,h/v}}'> $spr_hvfile

echo "OUTPUT (for HV spectral ratio) " $spr_hvfile_ew
paste $FILES| awk '{freq=$1;v=$2;ew=$6;ns=$10;h=ew
if(v!=0){printf "%g\t%g\n",freq,h/v}}'>$spr_hvfile_ew

echo "OUTPUT (for HV spectral ratio) " $spr_hvfile_ns
paste $FILES| awk '{freq=$1;v=$2;ew=$6;ns=$10;h=ns
if(v!=0){printf "%g\t%g\n",freq,h/v}}'>$spr_hvfile_ns

#echo "OUTPUT (for HV spectral ratio) " $spr_hvfile_denom
#paste $FILES| awk '{freq=$1;v=$2;ew=$6;ns=$10;h=ew+ns
#if(v!=0){printf "%g\t%g\n",freq,h}}' > $spr_hvfile_denom

