#!/bin/bash
# Shell script for Packege BIDO
# (C) 2012 I. Cho All Rights Reserved.

echo "<SPECRATIO PSD>"

for comp in $COMPS
do
i=1
j=2
while [ $j -le $nseis_total ]
do
file1=$outputdir2/SD"$i""$comp"_SD"$i"$comp.d 
file2=$outputdir2/SD"$j""$comp"_SD"$j"$comp.d 
FILES="$file1 $file2"
outfilepsdratio=$outputdir2/PSDRATIO"$i"_"$j"$comp.d 

for file in $FILES;do
. script/chkfile.sh $file; done

echo "OUTPUT (for Power Spectral Ratios) " $outfilepsdratio
paste $FILES| awk '{freq=$1;bunbo=$2;bunshi=$6;
if(bunbo!=0){psdratio=bunshi/bunbo 
printf "%g\t%g\n",freq,psdratio
}}'> $outfilepsdratio

let j=j+1
done
done
