#!/bin/bash
# Shell script for Packege BIDO
# (C) 2010 I. Cho All Rights Reserved.

# grammer check for seismfile

dtlines=`cat $seismfile   | grep '^#DT'     | wc -l | awk '{print $1}'`
complines=`cat $seismfile | grep '^#COMP'   | wc -l | awk '{print $1}'`
dt_char=`cat $seismfile   | grep '^#DT'     | awk '{print $2}'| awk '{if(/[0-9]/){print $1}}'`
comp_char=`cat $seismfile | grep '^#COMP'   | awk '{print $2}'| awk '{if(/[0-9]/){print $1}}'`
numlines=`cat $seismfile  | grep -v '^#'    | awk '{if(/[0-9]/){
if($4!=""){print $0}}}'   | wc -l | awk '{print $1}'`
numlines_err=`cat $seismfile | grep -v '^#' | awk '{if(/[0-9]/){
if($4==""){print $0}}}'   | wc -l | awk '{print $1}'`
numlines_err2=`cat $seismfile |grep -v '^#' | awk 'BEGIN{num0=0;num1=0;iderror=0}{if(/[0-9]/){if     ($4==1){num1=num1+1}else if($4==0){num0=num0+1}else {iderror=1}}}END{if(num1>1){iderror=1};print iderror}'`


if test "$id_miniature_array" == "1"
then
id_center=`cat $seismfile | grep -v '^#' | awk 'BEGIN{i=0}{
	   if(/[0-9]/){if($4==1){i=i+1}}}END{print i}'`
fi # test "$id_miniature_array" == "1"


if [ $numlines -eq 0 -o $numlines_err -ge 1 ];	then
    problem_in_seismfile=1
fi

if [ $numlines_err2 -eq 1 ];	then
    problem_in_seismfile=1
fi

if test "$dtlines" != "1" -o "$dt_char" == "" ; then
    problem_in_seismfile=1
else 
    dtnegative=`echo $dt_char | awk '{if($1>0){print 0}else{print 1}}'`
    if [ $dtnegative -eq 1 ];then
	problem_in_seismfile=1
    fi
fi

if test "$complines" != "1" -o "$comp_char" == "" ;then
    problem_in_seismfile=1
elif [ $comp_char -lt 1 -o $comp_char -gt 3 ];then
    problem_in_seismfile=1
fi

for code in `cat $seismfile | grep -v '^#' | awk '{if(/[0-9]/){print $3}}'`
do
file=$datadir/$code
if [ ! -f $file ]
then
    problem_in_seismfile=2
fi
done
