#!/bin/bash
# Shell script for Packege BIDO
# (C) 2009 I. Cho All Rights Reserved.

echo "<MKWAV3C>"
echo seismfile: $seismfile

originaldatafile=`cat $seismfile | grep -v '^#' | awk '{if(/[0-9]/){printf "%s/%s\n","'"$datadir"'",$3}}' | head -n 1`

echo "$originaldatafile used to estimate horizontal-to-vertical spectral ratios"
cat $originaldatafile | head -n 1 | grep ',' >& /dev/null
if test "$?" == "0"
then
cat $originaldatafile | awk 'BEGIN{FS=","}{print $1,$2}' > $udfile
cat $originaldatafile | awk 'BEGIN{FS=","}{print $1,$3}' > $ewfile
cat $originaldatafile | awk 'BEGIN{FS=","}{print $1,$4}' > $nsfile
else # if test "$?" == "0"
cat $originaldatafile | awk '{print $1,$2}' > $udfile
cat $originaldatafile | awk '{print $1,$3}' > $ewfile
cat $originaldatafile | awk '{print $1,$4}' > $nsfile
fi   # if test "$?" == "0"

echo OUTPUT: $udfile
echo OUTPUT: $ewfile
echo OUTPUT: $nsfile
